package com.example.blum.harrypotter;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import com.squareup.picasso.Picasso;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

//https://android--examples.blogspot.com/2017/02/android-volley-json-object-request.html
//https://android--examples.blogspot.com/2017/02/android-volley-json-array-request.html

public class MainActivity extends AppCompatActivity {

    private String url = "http://www1.lasalle.edu/~blum/c341wks/Harry_Potter_2/";
    private Context mContext;
    private Activity mActivity;
    public JSONArray myJSON_array;
    ImageView ivMovie;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        mContext = getApplicationContext();
        mActivity = MainActivity.this;

        final Spinner spMovie = (Spinner) findViewById(R.id.spMovie);
        final Button btnPlay = (Button) findViewById(R.id.btnPlay);
        ivMovie = (ImageView) findViewById(R.id.ivMovie);


        RequestQueue requestQueue = Volley.newRequestQueue(mContext);
        // Initialize a new JsonObjectRequest instance
        JsonObjectRequest jsonObjectRequest = new JsonObjectRequest(
                Request.Method.GET,
                url+"Potter.json",
                null,
                new Response.Listener<JSONObject>() {
                    @Override
                    public void onResponse(JSONObject response) {
                        // Process the JSON
                        try{
                            // Get the JSON array
                            final JSONArray myJSON_array = response.getJSONArray("films");
                            String[] movie_titles = new String[myJSON_array.length()];

                            // Loop through the array elements
                                    for(int i=0;i<myJSON_array.length();i++){
                                        // Get current json object
                                        JSONObject movie = myJSON_array.getJSONObject(i);

                                        // Get the current student (json object) data
                                        movie_titles[i] = movie.getString("title");
                                        //String director = movie.getString("director");
                                        //String writer = movie.getString("writer");

                                    } //end loop over array

                            ArrayAdapter<String> aaMovie = new ArrayAdapter<String>(getBaseContext(),   android.R.layout.simple_spinner_item, movie_titles);
                            aaMovie.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            spMovie.setAdapter(aaMovie);


                            spMovie.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                                @Override
                                public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                                    try {
                                        String file = myJSON_array.getJSONObject(i).getString("image");
                                        loadImageFromUrl(url + file);
                                    }catch(JSONException e){}

                                }

                                @Override
                                public void onNothingSelected(AdapterView<?> adapterView) {

                                }
                            });

                            btnPlay.setOnClickListener(new View.OnClickListener() {

                                @Override
                                public void onClick(View view) {
                                    int id = spMovie.getSelectedItemPosition();
                                    //Toast.makeText(getApplicationContext(), ""+id, Toast.LENGTH_LONG).show();

                                    try {
                                        String ytc = myJSON_array.getJSONObject(id).getString("youtubecode");
                                        //Toast.makeText(getApplicationContext(), ytc, Toast.LENGTH_LONG).show();
                                        startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v="+ytc)));
                                    }catch(JSONException e){

                                    }
                                }
                            });



                                }
                                catch (JSONException e){
                                    e.printStackTrace();
                                }
                            }
                        },
                        new Response.ErrorListener(){
                            @Override
                            public void onErrorResponse(VolleyError error){
                                // Do something when error occurred
                            }
                        }
                );

                // Add JsonObjectRequest to the RequestQueue
                requestQueue.add(jsonObjectRequest);

    }//end onCreate

    private void loadImageFromUrl(String url){
        Picasso.with(this).load(url).placeholder(R.mipmap.ic_launcher)
                .error(R.mipmap.ic_launcher)
                .into(ivMovie, new com.squareup.picasso.Callback() {
                    @Override
                    public void onSuccess() {

                    }

                    @Override
                    public void onError() {

                    }
                });
    }

}//end MainActivity
